#line 1 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock/I2C 16x2, 20x2, 20x4 LCD 8051/I2C LCD.c"

sbit Soft_I2C_Scl at P1_0_bit;
sbit Soft_I2C_Sda at P1_1_bit;
#line 26 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock/I2C 16x2, 20x2, 20x4 LCD 8051/I2C LCD.c"
char txt1[] = "I2C LCD";
char txt2[] = "16x2, 20x2, 20x4";
char txt3[] = "AT89C4051";
char txt4[] = "11.0592 MHz";

void I2C_LCD_Cmd(char out_char) {

 char hi_n, lo_n;
 char rs = 0x00;

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 Soft_I2C_Start();
 Soft_I2C_Write( 0x4E );
 Soft_I2C_Write(hi_n | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(hi_n | rs | 0x00 | 0x08);
 Delay_us(100);
 Soft_I2C_Write(lo_n | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(lo_n | rs | 0x00 | 0x08);
 Soft_I2C_Stop();

 if(out_char == 0x01)Delay_ms(2);
}

void I2C_LCD_Chr(char row, char column, char out_char) {

 char hi_n, lo_n;
 char rs = 0x01;

 switch(row){

 case 1:
 I2C_LCD_Cmd(0x80 + (column - 1));
 break;
 case 2:
 I2C_LCD_Cmd(0xC0 + (column - 1));
 break;
 case 3:
 I2C_LCD_Cmd(0x94 + (column - 1));
 break;
 case 4:
 I2C_LCD_Cmd(0xD4 + (column - 1));
 break;
 };

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 Soft_I2C_Start();
 Soft_I2C_Write( 0x4E );
 Soft_I2C_Write(hi_n | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(hi_n | rs | 0x00 | 0x08);
 Delay_us(100);
 Soft_I2C_Write(lo_n | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(lo_n | rs | 0x00 | 0x08);
 Soft_I2C_Stop();
}

void I2C_LCD_Chr_Cp(char out_char) {

 char hi_n, lo_n;
 char rs = 0x01;

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 Soft_I2C_Start();
 Soft_I2C_Write( 0x4E );
 Soft_I2C_Write(hi_n | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(hi_n | rs | 0x00 | 0x08);
 Delay_us(100);
 Soft_I2C_Write(lo_n | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(lo_n | rs | 0x00 | 0x08);
 Soft_I2C_Stop();
}


void I2C_LCD_Init() {

 char rs = 0;

 Delay_ms(150);

 Soft_I2C_Start();
 Soft_I2C_Write( 0x4E );
 Delay_ms(30);

 Soft_I2C_Write(0x30 | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(0x30 | rs | 0x00 | 0x08);
 Delay_ms(30);

 Soft_I2C_Write(0x30 | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(0x30 | rs | 0x00 | 0x08);
 Delay_ms(30);

 Soft_I2C_Write(0x30 | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(0x30 | rs | 0x00 | 0x08);
 Delay_ms(20);

 Soft_I2C_Write(0x20 | rs | 0x04 | 0x08);
 Delay_us(50);
 Soft_I2C_Write(0x20 | rs | 0x00 | 0x08);
 Soft_I2C_Stop();

 Delay_ms(10);

 I2C_LCD_Cmd(0x28);
 I2C_LCD_Cmd(0x06);
}

void I2C_LCD_Out(char row, char column, char *text) {
 while(*text)
 I2C_LCD_Chr(row, column++, *text++);
}

void I2C_LCD_Out_Cp(char *text) {
 while(*text)
 I2C_LCD_Chr_Cp(*text++);
}

void main() {

 P1 = 0x00;

 Soft_I2C_Init();

 I2C_LCD_Init();
 I2C_LCD_Cmd( 0x0C );
 I2C_LCD_Cmd( 0x01 );
 I2C_LCD_Out(1,1,txt1);
 I2C_LCD_Out(2,1,txt2);
 I2C_LCD_Out(3,1,txt3);
 I2C_LCD_Out(4,1,txt4);

 while(1) {

 }
}
